clear all
close all
whos

im1 = (imread('camrot01.jpg')); % obrazek vpravo
im2 = (imread('camrot02.jpg')); % obrazek vlevo

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% vypocet matice omega
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

index=1;
for j = 2:6
    load(sprintf('rccorr01-%02d.mat', j)); % souradnice "identickych" bodu
    x = u(4:6,:);
    y = u(1:3,:);

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % vypocet matice H
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    for i = 1: size(u,2)
        A(i*3 - 2, 1:3) = y(3,i)*x(:,i)'; A(i*3 - 2, 7:9) = -y(1,i)*x(:,i)';
        A(i*3 - 1, 4:6) = y(3,i)*x(:,i)'; A(i*3 - 1, 7:9) = -y(2,i)*x(:,i)';
        A(i*3    , 1:3) = y(2,i)*x(:,i)'; A(i*3    , 4:6) = -y(1,i)*x(:,i)';
    end

    [U,S,V] = svd(A);
    N = V(:,9);
    H = inv( [N(1:3)'; N(4:6)'; N(7:9)'] );

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % slucovani matice B
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    H = H / (abs(det(H))^(1/3));
    for k = 1:3
        for l = k:3
            B(index,:) = [H(1,k)*H(1,l)   H(1,k)*H(2,l)+H(2,k)*H(1,l)     H(1,k)*H(3,l)+H(3,k)*H(1,l)     H(2,k)*H(2,l)   H(2,k)*H(3,l)+H(3,k)*H(2,l)     H(3,k)*H(3,l)];
            index = index + 1;
        end
    end
    
    B(index-6:index-1,:) = B(index-6:index-1,:) - eye(6);
    clear A U S V N i j k l x y u;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% vypocet matice B
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[U,S,V] = svd(B);
N = V(:,6);
O = [N(1:3)'; N(2) N(4:5)'; N(3) N(5:6)'];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% vypocet matice K
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
K = inv(chol(O/O(3,3)));
K = K/K(3,3);

clear s U S V N O B H index;